---
apiVersion: argoproj.io/v1alpha1
kind: Workflow
metadata:
  name: cacao-install-{{ trunc 10 .Values.cacao_version }}-{{ now | unixEpoch }}
  labels:
    commit: {{ .Values.cacao_version }}
spec:
  ttlStrategy:
    {{- /* default 30 days ttl */}}
    secondsAfterCompletion: {{ .Values.workflow_ttl_sec | default 2592000 }}
  serviceAccountName: argo
  entrypoint: install-cacao
  volumes:
  - name: ssh-vol
    secret:
      secretName: {{ .Values.ssh_secret_name | default "ssh-secret" }}
      defaultMode: 0600
  templates:
  - name: install-cacao
    activedeadlineseconds: 900
    script:
      image: registry.gitlab.com/cyverse/cacao/ansible:latest
      command: [bash]
{{/*
- symbolic link private ssh key
- add host key for config repo domain if provided
- clone cacao repo
- clone config repo
- checkout desired cacao version (branch/tag/commit)
- copy config.yaml and hosts.yaml
- install ansible role & collection requirements
- run install/playbook-cacao.yaml
*/}}
      source: |
        set -e

        export GIT_SSH_COMMAND='ssh -i /secret/ssh/private-key'

        {{- if .Values.ssh_repo_domain }}
        mkdir -p ~/.ssh
        ssh-keyscan -t ed25519 {{ .Values.ssh_repo_domain }} >> ~/.ssh/known_hosts
        ssh-keyscan -t rsa {{ .Values.ssh_repo_domain }} >> ~/.ssh/known_hosts

        {{- end }}
        cd /opt
        git clone {{ .Values.config_repo }} cacao-config --depth 1
        git clone https://gitlab.com/cyverse/cacao.git cacao --depth 1 --no-single-branch
        chmod -R o= /opt

        cd /opt/cacao
        git fetch
        git checkout {{ .Values.cacao_version }}

        cd /opt/cacao/install
        cp /opt/cacao-config/config.yaml /opt/cacao/install/config.yaml
        cp /opt/cacao-config/hosts.yaml /opt/cacao/install/hosts.yaml

        ansible-galaxy role install -r ./requirements.yaml
        ansible-galaxy collection install -r ./requirements-collections.yaml

        export ANSIBLE_HOST_KEY_CHECKING=False
        ansible-playbook ./playbook-cacao.yaml -i ./hosts.yaml --key-file /secret/ssh/private-key
      volumeMounts:
      - name: ssh-vol
        mountPath: "/secret/ssh"
